﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Framework
{
    public class TriangleMesh
    {
        private Point3D[] points;
        private Triangle[] triangles;
        private Point3D[] normals;
        private ColorRGBA[] colors;
        private Point3D[] vectors;
        
        private BoundingBox boundingBox;

        public BoundingBox BoundingBox
        {
            get {
                if (boundingBox == null)
                    boundingBox = new BoundingBox(this.points);
                return boundingBox; }
            set { boundingBox = value; }
        }

        public Point3D[] Vectors
        {
            get { return vectors; }
            set { vectors = value; }
        }

        public Point3D[] Normals
        {
            get { return normals; }
            set { normals = value; }
        }

        public ColorRGBA[] Colors
        {
            get { return colors; }
            set { colors = value; }
        }

        public Point3D[] Points
        {
            get { return points; }
            set { points = value; }
        }

        public Triangle[] Triangles
        {
            get { return triangles; }
            set { triangles = value; }
        }

        public TriangleMesh()
        {
        }

        public override string ToString()
        {
            string str = this.GetType().FullName + ":\r\n";

            if (points != null)
            {
                str += "points: " + points.Length + "\r\n";
            }

            if (triangles != null)
            {
                str += "triangles: " + triangles.Length + "\r\n";
            }
            return str;
        }

        public TriangleMesh DeepCopy()
        {
            TriangleMesh result = new TriangleMesh();
            result.points = (Point3D[])this.points.Clone();
            result.triangles = (Triangle[])this.triangles.Clone();
            return (result);
        }
    }
}
