﻿using System;
using SlimDX;
using System.Windows.Media;
using System.ComponentModel;

namespace SlimDXRenderSystem.Core
{
    public class Light
    {
        private String name;
        private LightStruct light;
        private LightType type;

        public String Name
        {
            get { return name; }
            set { name = value; }
        }

        public Vector3 Direction
        {
            get { return light.Direction; }
            set { light.Direction = value; }
        }

        public Vector3 Position
        {
            get { return light.Position; }
            set { light.Position = value; }
        }

        public Color Ambient
        {
            get { return Color.FromScRgb(light.Ambient.W, light.Ambient.X, light.Ambient.Y, light.Ambient.Z); }
            set { light.Ambient = new Vector4(value.ScR, value.ScG, value.ScB, 1); }
        }

        public Color Diffuse
        {
            get { return Color.FromScRgb(light.Ambient.W, light.Diffuse.X, light.Diffuse.Y, light.Diffuse.Z); }
            set { light.Diffuse = new Vector4(value.ScR, value.ScG, value.ScB, 1); }
        }

        public Color Specular
        {
            get { return Color.FromScRgb(light.Specular.W, light.Specular.X, light.Specular.Y, light.Specular.Z); }
            set { light.Specular = new Vector4(value.ScR, value.ScG, value.ScB, 1); }
        }

        public float SpotInnerCone
        {
            get { return light.SpotInnerCone; }
            set { light.SpotInnerCone = value; }
        }

        public float SpotOuterCone
        {
            get { return light.SpotOuterCone; }
            set { light.SpotOuterCone = value; }
        }

        public float Radius
        {
            get { return light.Radius; }
            set { light.Radius = value; }
        }

        public LightType Type
        {
            get { return type; }
            set { type = value; }
        }

        [Browsable(false)]
        public LightStruct LightStruct
        {
            get { return light; }
        }

        public Light(string name)
        {
            this.name = name;
            light = new LightStruct();
            type = LightType.Directional;
        }
    }
}
