﻿using System;
using SlimDX;

namespace SlimDXRenderSystem.Direct3DBase
{
    public abstract class Mesh
    {
        public abstract int Vertices { get; }
        public abstract int Primitives{ get; }

        public abstract void Draw();
        public abstract void InitVertexBuffer(Vector3[] points, Vector3[] normals, int[] colors);
        public abstract void AddIndexBuffer(string name, MeshType type, uint[] indices);
        public abstract void EnableDrawIndices(string name);
        public abstract void DisableDrawIndices(string name);
        public abstract void Dispose();
    }
}
