﻿using System;
using SlimDX;


namespace SlimDXRenderSystem.Managers
{
    public class EffectsManager : Core.Singleton<EffectsManager>
    {
        #region Fields
        private Direct3D9.Effect effect9;

        #region Properties

        #endregion
        #endregion

        #region Public Methods
        public void LoadFromFile(string filename)
        {
            switch (RenderManager.Instance.D3dVersion)
            {
                case D3DVersion.Direct3D9:
                    if (effect9 == null)
                        effect9 = new Direct3D9.Effect();
                    try
                    {
                        effect9.LoadFromFile(filename);
                    }
                    catch (Exception e)
                    {
                        System.Windows.Forms.MessageBox.Show(e.Message);
                    }
                    finally
                    {
                        //TODO: Use default effect
                    }
                    break;
            }
        }

        public void BeginEffect()
        {

        }

        public void Dispose()
        {
            if (effect9 != null && !effect9.Disposed)
            {
                effect9.Dispose();
                effect9 = null;
            }

        }
        #endregion
    }
}
