﻿using System;
using System.Windows;
using System.Drawing;
using System.Runtime.InteropServices;
using SlimDXRenderSystem.Managers;

namespace SlimDXRenderSystem
{
    /// <summary>
    /// Rendering control using SlimDX.
    /// </summary>
    /*public class RendererControl : Control
    {
        bool needsReset = false;
        bool render = false;
        private Action updateAction = null;

        public Action UpdateAction
        {
            set { updateAction = value; }
        }

        /// <summary>
        /// Dummy constructor.
        /// </summary>
        public RendererControl()
        {
            
        }

        #region Events
        /// <summary>
        /// Initialization of all subcomponents. This method is call only once at the control creation.
        /// </summary>
        protected override void OnCreateControl()
        {
            base.OnCreateControl();
            if (!DesignMode)
            {
                try
                {
                    RenderManager.Instance.Initialize(this.FindForm(), this);
                    InputManager.Instance.Initialize(this.FindForm().Handle);
                    TimeManager.Instance.Initialize();
                    SceneManager.Instance.Initialize();
                    Application.Idle += new EventHandler(Application_Idle);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message, e.StackTrace);
                    this.Dispose();
                }
            }
        }

        protected override void OnGotFocus(EventArgs e)
        {
            base.OnGotFocus(e);
            InputManager.Instance.AcquiredKeyboard = true;
        }

        protected override void OnLostFocus(EventArgs e)
        {
            base.OnLostFocus(e);
            InputManager.Instance.AcquiredKeyboard = false;
        }

        protected override void OnMouseClick(MouseEventArgs e)
        {
            base.OnMouseClick(e);
            Focus();
        }

        protected override void OnMouseEnter(EventArgs e)
        {
            base.OnMouseEnter(e);
            InputManager.Instance.AcquiredMouse = true;
        }

        protected override void OnMouseLeave(EventArgs e)
        {
            base.OnMouseLeave(e);
            InputManager.Instance.AcquiredMouse = false;
        }

        /// <summary>
        /// On resise the client area, determine if reset the device or not.
        /// </summary>
        /// <param name="e"></param>
        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);
            if (Created && !DesignMode)
            {
                // When the client area size is less then specified value, the device wont reset (for minimalization purpose)
                needsReset = ((this.ClientSize.Height > 32) && (this.ClientSize.Width > 32)) ? true : false;
                render = false;
            }
        }

        /// <summary>
        /// On paint event useful for VS designer.
        /// </summary>
        /// <param name="pe"></param>
        protected override void OnPaint(PaintEventArgs pe)
        {
            if (DesignMode)
            {
                pe.Graphics.Clear(Color.Black);
                pe.Graphics.DrawString(Name, Font, Brushes.White, PointF.Empty);
            }
            if (!RenderManager.Instance.WizardShown)
                render = true;
        }

        /// <summary>
        /// Clear all resources we initialize.
        /// </summary>
        /// <param name="disposing"></param>
        protected override void Dispose(bool disposing)
        {
            SceneManager.Instance.Dispose();
            InputManager.Instance.Dispose();
            RenderManager.Instance.Dispose();
            EffectManager.Instance.Dispose();
            //FontManager.Instance.Dispose();
            base.Dispose(disposing);
        }
        #endregion

        #region Static Render loop
        /// <summary>
        /// We are using the render loop recommended by Tom Miller in his blog http://blogs.msdn.com/tmiller/archive/2005/05/05/415008.aspx
        /// But we will use the render loop statically to prevent one instance of the control to hook it alone.
        /// </summary>
        [StructLayout(LayoutKind.Sequential)]
        private struct NativeMessage
        {
            public IntPtr hWnd;
            public uint msg;
            public IntPtr wParam;
            public IntPtr lParam;
            public uint time;
            public System.Drawing.Point p;
        }

        /// <summary>
        /// Peek message override from non managed code.
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="hWnd"></param>
        /// <param name="messageFilterMin"></param>
        /// <param name="messageFilterMax"></param>
        /// <param name="flags"></param>
        /// <returns></returns>
        [System.Security.SuppressUnmanagedCodeSecurity] // We won't use this maliciously
        [DllImport("User32.dll", CharSet = CharSet.Auto)]
        private static extern bool PeekMessage(out NativeMessage msg, IntPtr hWnd, uint messageFilterMin, uint messageFilterMax, uint flags);

        /// <summary>
        /// Is application idle.
        /// </summary>
        private static bool AppStillIdle
        {
            get
            {
                NativeMessage msg;
                return !PeekMessage(out msg, IntPtr.Zero, 0, 0, 0);
            }
        }

        /// <summary>
        /// When no messages waiting, render or reset the device.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Application_Idle(object sender, EventArgs e)
        {
            while (AppStillIdle)
            {
                if (needsReset)
                {
                    RenderManager.Instance.Reset();
                    SceneManager.Instance.Camera.AspectRatio = (float)this.Width / this.Height;
                    needsReset = false;
                    render = true;
                }
                else if (render)
                {
                    InputManager.Instance.Update();
                    RenderManager.Instance.Render();
                    if (updateAction != null)
                        updateAction.Invoke();
                }
            }
        }

        #endregion
    }*/
}
