﻿using System;
using SlimDX;

namespace SlimDXRenderSystem
{
    public struct Vertex
    {
        public Vector4 Position;
        public Vector4 Normal;
        public int Color;

        public static int SizeInBytes = Vector4.SizeInBytes + Vector4.SizeInBytes + sizeof(int);
    }

    public struct LightStruct
    {
        
        public Vector3 Direction;
        public Vector3 Position;
        public Vector4 Ambient;
        public Vector4 Diffuse;
        public Vector4 Specular;
        public float SpotInnerCone;
        public float SpotOuterCone;
        public float Radius;

        public static int SizeInBytes = 2 * Vector3.SizeInBytes + 3 * Vector4.SizeInBytes + 3 * sizeof(float);
    }

    public struct MaterialStruct
    {
        public Vector4 Ambient;
        public Vector4 Diffuse;
        public Vector4 Emissive;
        public Vector4 Specular;
        public float Shininess;

        public static int SizeInBytes = 4 * Vector4.SizeInBytes + sizeof(float);
    };
}
