﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Microsoft.Win32;

namespace MeshBrowser
{
    /// <summary>
    /// Interaction logic for AssociationsDialog.xaml
    /// </summary>
    public partial class AssociationsDialog : Window
    {
        public bool[] orig;

        public AssociationsDialog()
        {
            InitializeComponent();
            orig = new bool[7];

            if (isAssociated(".obj"))
            {
                cbObj.IsChecked = true;
                orig[0] = true;
            }
            if (isAssociated(".tri"))
            {
                cbTri.IsChecked = true;
                orig[1] = true;
            }
            if (isAssociated(".stl"))
            {
                cbStl.IsChecked = true;
                orig[2] = true;
            }
            if (isAssociated(".wrl"))
            {
                cbWrl.IsChecked = true;
                orig[3] = true;
            }
            if (isAssociated(".ply"))
            {
                cbPly.IsChecked = true;
                orig[4] = true;
            }
            if (isAssociated(".cmx"))
            {
                cbCmx.IsChecked = true;
                orig[5] = true;
            }
            if (isAssociated(".off"))
            {
                cbOff.IsChecked = true;
                orig[6] = true;
            }
        }

        bool isAssociated(string ext)
        {
            try
            {
                RegistryKey key = Registry.ClassesRoot.OpenSubKey(ext);
                if (key == null)
                    return false;
                string v = (string)key.GetValue("");
                RegistryKey key2 = Registry.ClassesRoot.OpenSubKey(v);
                RegistryKey Shell = key2.OpenSubKey("Shell");
                if (Shell == null)
                    return false;
                RegistryKey Open = Shell.OpenSubKey("open");
                if (Open == null)
                    return false;
                RegistryKey Command = Open.OpenSubKey("command");
                if (Command == null)
                    return false;
                string cmd = (string)Command.GetValue("");
                if (cmd.Contains(Environment.GetCommandLineArgs()[0]))
                    return true;
                else
                    return false;
            }
            catch
            {
                return (false);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
        }
    }
}
