﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Data;
using SlimDXRenderSystem.Managers;


namespace MeshBrowser
{
    struct KeyBinding
    {
        public string Action
        {
            get; set;
        }
        public string Key
        {
            get;
            set;
        }

        public KeyBinding(string a, string k)
        {
            Action = a;
            Key = k;
        }
    }

    /// <summary>
    /// Interaction logic for SettingsWindow.xaml
    /// </summary>
    public partial class SettingsWindow : Window
    {
        public SettingsWindow()
        {
            InitializeComponent();
            List<KeyBinding> dt = new List<KeyBinding>();
            foreach (SlimDX.DirectInput.Key k in SlimDXRenderSystem.Managers.InputManager.Instance.KeyClickActions.Keys)
            {
                dt.Add(new KeyBinding(SlimDXRenderSystem.Managers.InputManager.Instance.KeyClickActions[k].Method.Name, k.ToString()));
            }
            foreach (SlimDX.DirectInput.Key k in SlimDXRenderSystem.Managers.InputManager.Instance.KeyIsPressedActions.Keys)
            {
                dt.Add(new KeyBinding(SlimDXRenderSystem.Managers.InputManager.Instance.KeyIsPressedActions[k].Method.Name, k.ToString()));
            }
            this.dataGrid.ItemsSource = dt.ToArray();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
