﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WpfAnimatedGif;
using System.Reflection;
using System.Threading;

namespace MeshBrowser
{
    /// <summary>
    /// Interaction logic for WelcomeWizard.xaml
    /// </summary>
    public partial class WelcomeWizard : Window
    {
        public WelcomeWizard()
        {
            InitializeComponent();

            new Thread(delegate()
            {
                this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.SystemIdle, (Action)delegate ()
                {
                    Assembly assembly = this.GetType().Assembly;
                    string assemblyName = assembly.ToString().Split(',')[0];
                    Uri uri = new Uri(String.Format("pack://application:,,,/{0};component/Resources/MBRotate.gif", assemblyName));
                    ImageBehavior.SetAnimatedSource(gif1, new BitmapImage(uri));
                    uri = new Uri(String.Format("pack://application:,,,/{0};component/Resources/MBRoll.gif", assemblyName));
                    ImageBehavior.SetAnimatedSource(gif2, new BitmapImage(uri));
                    uri = new Uri(String.Format("pack://application:,,,/{0};component/Resources/MBZoom.gif", assemblyName));
                    ImageBehavior.SetAnimatedSource(gif3, new BitmapImage(uri));
                    uri = new Uri(String.Format("pack://application:,,,/{0};component/Resources/MBTranslate.gif", assemblyName));
                    ImageBehavior.SetAnimatedSource(gif4, new BitmapImage(uri));
                    uri = new Uri(String.Format("pack://application:,,,/{0};component/Resources/MBLighting.gif", assemblyName));
                    ImageBehavior.SetAnimatedSource(gif5, new BitmapImage(uri));
                });
            }
            ).Start();
        }

        private void NextButton_Click(object sender, RoutedEventArgs e)
        {
            this.tabControl1.SelectedIndex++;
            if (tabControl1.SelectedIndex == 7)
                NextButton.IsEnabled = false;
            if (tabControl1.SelectedIndex == 1)
                PreviousButton.IsEnabled = true;
        }

        private void PreviousButton_Click(object sender, RoutedEventArgs e)
        {
            this.tabControl1.SelectedIndex--;
            if (tabControl1.SelectedIndex == 0)
                PreviousButton.IsEnabled = false;
            if (tabControl1.SelectedIndex == 6)
                NextButton.IsEnabled = true;
        }

        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
